package com.malk.mc.controller;

import com.alibaba.fastjson.JSONObject;
import com.malk.server.common.McException;
import com.malk.server.common.McR;
import com.malk.server.dingtalk.DDR_New;
import com.malk.service.dingtalk.DDClient;
import com.malk.service.dingtalk.DDClient_Group;
import com.malk.service.dingtalk.DDClient_Report;
import com.malk.utils.UtilMap;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import com.malk.service.dingtalk.DDClient_Attendance;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.stream.Collectors;

@Slf4j
@RestController
@RequestMapping("/dd")
public class McDdController {

    @Autowired
    private DDClient_Group ddClientGroup;
    @Autowired
    private DDClient_Report ddClientReport;
    @Autowired
    private DDClient ddClient;

    @Autowired
    private DDClient_Attendance ddClientAttendance;



    @PostMapping("/group/createGroupByTemp")
    public McR createGroupByTemp(@RequestBody JSONObject param){
        log.info("创建场景群:{}",param);
        McException.assertParamException_Null(param,"title","template_id","owner_user_id","user_ids");
        String id=ddClientGroup.createGroupByTemp(ddClient.getAccessToken(),param.getString("title"),
                param.getString("template_id"),param.getString("owner_user_id"),param.getString("user_ids"));
        return McR.success(id);
    }

    @PostMapping("/report/create")
    public McR createReport(@RequestBody JSONObject param){
        log.info("创建日志:{}",param);
        McException.assertParamException_Null(param,"template_id","to_chat","dd_from","userid","contents");
        JSONObject contents=param.getJSONObject("contents");
        List list=new ArrayList();
        for(String key:contents.keySet()){
            list.add(contents.getJSONObject(key));
        }
        String result=ddClientReport.createReport(ddClient.getAccessToken(),param.getString("to_userids"),param.getString("to_cids")
                ,param.getString("template_id"),param.getBoolean("to_chat"),param.getString("dd_from"),param.getString("userid"),
                list);
        return McR.success(result);
    }

    @PostMapping("/attendence/getAttendenceDetail")
    public McR getAttendenceDetail(@RequestBody JSONObject param) throws ParseException {
        log.info("考勤参数详情:{}",param);
        McException.assertParamException_Null(param,"checkDateFrom","checkDateTo","userIds");
        String accessToken = ddClient.getAccessToken();
        List userIds = (List) param.get("userIds");
        String checkDateFrom = param.getString("checkDateFrom")+" 00:00:00";
        String checkDateTo = param.getString("checkDateTo")+" 00:00:00";
        List<Map> results = ddClientAttendance.listAttendanceRecord(accessToken, userIds, checkDateFrom, checkDateTo);
        log.info("获取考勤详情:{}",results);
        Set<String> addressList = new HashSet<>();
        String address = "";
        for(Map result:results){
            System.out.println("result:"+result.get("userAddress"));
            addressList.add(result.get("userAddress").toString()) ;
        }
        System.out.println("address:"+addressList) ;
         address = addressList.stream().collect(Collectors.joining(","));
        return McR.success(address);
    }

}
